REM Last Changed: 10/22/2001
ECHO OFF
CLS

ECHO Building A Sample TSR Event Hook

call clean.bat

REM About the switches used for compiling the TSR:
REM 
REM I use -O3 because I think that it is important to have a hook
REM execute as fast as possible both for the user's perception
REM and for battery life. 
REM
REM -outputbin to produce a binary form of the hook so it can be converted 
REM with ttbin2hex to an array for install.c
REM
REM you may want to add the switches -Wall and -W so tigcc does more
REM error checking


REM Pre-Compile the Tsr Event Hook. This will output a file called hook.bin
REM you may want to experiment with -fomit-frame-pointer, -mpcrel, and -mregparm 
REM to see if they decrease the size of your project. If you try this, be sure 
REM to test your project and make sure that these options do not have negative
REM side effects
tigcc -O3 -W -Wall -outputbin hook.c

REM convert the raw binary image to an array
ttbin2hex -a tsr -ss 2 -se 1 hook.bin array.h


REM compile the install program with the tsr hook included as an array.
tigcc -Os -W -Wall -mpcrel -fomit-frame-pointer Install.c h220xtsr.a

del hook.bin

ECHO Build Completed!
ECHO ON
