//Copyright (C) 2003 Daniel DeGraaf
#define NO_h220TSR

	#define NO_EXIT_SUPPORT
	#define NO_AMS_CHECK
	#define OPTIMIZE_ROM_CALLS
	#define NO_CALC_DETECT
	#define USE_TI89
	#define USE_TI92PLUS
	#define USE_V200

#define fatal(s) {ST_showHelp(s);return;}

#include <tigcclib.h>			//Include All Header Files
#ifndef NO_h220TSR
	#include "h220xTSR.h"	 //Kevin Kofler's hw2 ams2 tsr support
#endif
#include "array.h"			//The pre-compiled EVENT HOOK

//This Code needs TIGCC 0.94 beta 19 at the very least to function properly
#if __TIGCC__==0 && __TIGCC_MINOR__< 94 && __TIGCC_BETA__ < 19
	#error Old TIGCC Version -- Check tigcc.ticalc.org for updates
#endif

// Main Function
void _main(void) {
	volatile HANDLE tsrHandle; 		 //Handle of allocated mem for the Hook
	char		*pTsr;	 							//a pointer to the actual mem for the Hook
#ifndef NO_h220TSR
	//sort of like a call to a permanent version of enter_ghost_space();
		if(!h220xTSR()) fatal("Low RAM!");
#endif

	//allocate RAM for the Event Hook
		if(!(tsrHandle=HeapAllocHigh(sizeof(tsr)))) fatal("Low RAM!");

	//get a pointer to the actual mem and make it point in the "ghost space"
	//ghost space is essentially a shadow of regular ram which is not protected very
	//well by the hardware... subtract 0x40000 to get the real address
		pTsr=HeapDeref(tsrHandle)+0x40000;

	//Copy The tsr array to its new location
		memcpy(pTsr,tsr,sizeof(tsr));

		CESI tmp = top_estack;
		if (*tmp != POSINT_TAG) fatal("No argument!");
		long from=GetIntArg(tmp);
		if (*tmp != POSINT_TAG) fatal("No argument!");
		long to  =GetIntArg(tmp);

	//rename and change addresses
		sprintf(pTsr+8,"%-4lx",from);
		*(WORD*)(pTsr+28)=from;
		*(WORD*)(pTsr+36)=to;
		
	//Save the Old tsr hook's address for the uninstall prog and for this hook to call
		*(DWORD*)(pTsr+12)=(DWORD)EV_hook;

		EX_patch(pTsr,pTsr+sizeof(tsr));
		EV_hook=(EVENT_HANDLER)&pTsr[16];

		fatal("Redirect Installed");
}
